<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>HttpRequestErrorProvider</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/core/service/http/ErrorInterceptor.ts</code>
        </p>





            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#_handled">_handled</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#_type">_type</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#onTechnicalError">onTechnicalError</a>
                            </li>
                            <li>
                                <a href="#onValidationError">onValidationError</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(_type: <a href="../undefineds/ErrorType.html">ErrorType</a>, error: <a href="../interfaces/Model.html">TechnicalErrorModel | ValidationErrorModel</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="92" class="link-to-prism">src/app/core/service/http/ErrorInterceptor.ts:92</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>_type</td>
                                                  
                                                        <td>
                                                                    <code><a href="../miscellaneous/enumerations.html#ErrorType" target="_self" >ErrorType</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>error</td>
                                                  
                                                        <td>
                                                                    <code><a href="../interfaces/Model.html" target="_self" >TechnicalErrorModel | ValidationErrorModel</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_handled"></a>
                        <span class="name">
                            <b>
                            _handled
                            </b>
                            <a href="#_handled"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>_handled:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>false</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="92" class="link-to-prism">src/app/core/service/http/ErrorInterceptor.ts:92</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_type"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            _type
                            </b>
                            <a href="#_type"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_type:     <code><a href="../miscellaneous/enumerations.html#ErrorType" target="_self" >ErrorType</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../miscellaneous/enumerations.html#ErrorType" target="_self" >ErrorType</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="94" class="link-to-prism">src/app/core/service/http/ErrorInterceptor.ts:94</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="onTechnicalError"></a>
                        <span class="name">
                            <b>
                            onTechnicalError
                            </b>
                            <a href="#onTechnicalError"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>onTechnicalError(errorKey: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, handler: (error: <a href="../interfaces/Model.html">TechnicalErrorModel</a>) => void)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="98" class="link-to-prism">src/app/core/service/http/ErrorInterceptor.ts:98</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>errorKey</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                                <tr>
                                                        <td>handler</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>this</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="onValidationError"></a>
                        <span class="name">
                            <b>
                            onValidationError
                            </b>
                            <a href="#onValidationError"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>onValidationError(exceptionClassName: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, handler: (error: <a href="../interfaces/Model.html">ValidationErrorModel</a>) => void)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="106" class="link-to-prism">src/app/core/service/http/ErrorInterceptor.ts:106</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>exceptionClassName</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                                <tr>
                                                        <td>handler</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>this</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &#x27;@angular/core&#x27;;
import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from &#x27;@angular/common/http&#x27;;
import { Observable } from &#x27;rxjs/Observable&#x27;;
import { ValidationErrorModel } from &#x27;./validation.error.model&#x27;;
import { TechnicalErrorModel } from &#x27;./technical.error.model&#x27;;
import { HttpParameters } from &#x27;./http.parameters.service&#x27;;
import { MatDialog } from &#x27;@angular/material&#x27;;
import { BusinessErrorDialogComponent } from &#x27;../../business-error-dialog/business-error-dialog.component&#x27;;
import { TechnicalErrorDialogComponent } from &#x27;../../technical-error-dialog/technical-error-dialog.component&#x27;;
import { DateInterceptor } from &#x27;./DateInterceptor&#x27;;

/**
 * Handle http call response errors. Distinguish Business errors, technical server errors and other errors.
 *
 * A business errors (http status 400) is left to process by the initiator (typically a component controller).
 * If not handled (ie &#x27;errorHandled&#x27; property of error object is still false after initiator&#x27;s error callback
 * execution), then show a modal dialog (BusinessErrorDialogComponent)
 *
 * Any technical error (http status 500) triggers the display of a modal dialog (TechnicalErrorDialogComponent) and
 * then is handed to the initiator&#x27; error callback
 *
 * Other errors are handed to the initiator&#x27; error callback and then an Error is thrown
 * @param httpCall
 * @returns {any}
 */
@Injectable()
export class ErrorInterceptor implements HttpInterceptor {

  technicalErrorDialogIsOpen &#x3D; false;


  constructor(private httpParams: HttpParameters, private dialog: MatDialog) {
  }

  intercept(req: HttpRequest&lt;any&gt;, next: HttpHandler): Observable&lt;HttpEvent&lt;any&gt;&gt; {
    return Observable.create(subscriber &#x3D;&gt; {
      next.handle(req).subscribe(
        res &#x3D;&gt; subscriber.next(res),
        err &#x3D;&gt; {
          let errorProvider: HttpRequestErrorProvider;
          let error: ValidationErrorModel | TechnicalErrorModel;
          if (err.status &#x3D;&#x3D;&#x3D; 400) {
            error &#x3D; JSON.parse(err.error, DateInterceptor.parseDateFields) as ValidationErrorModel;
            this.httpParams.translateMessages(error);
            errorProvider &#x3D; new HttpRequestErrorProvider(ErrorType.Validation, error);
          } else {

            if (err.status &#x3D;&#x3D;&#x3D; 500) {
              error &#x3D; JSON.parse(err.error, DateInterceptor.parseDateFields);
            } else if (err.status &#x3D;&#x3D;&#x3D; 403) {
              error &#x3D; new TechnicalErrorModel(err.status, &quot;global.errors.forbidden&quot;);
            } else {
              error &#x3D; new TechnicalErrorModel(err.status, &quot;global.errors.unknown&quot;)
            }

            errorProvider &#x3D; new HttpRequestErrorProvider(ErrorType.Technical, error);
            if (err.status &#x3D;&#x3D;&#x3D; 401) {
              errorProvider._handled &#x3D; true;
            }
          }
          try {
            subscriber.error(errorProvider);
          }
          finally {
            if (!errorProvider._handled) {
              if (errorProvider._type &#x3D;&#x3D; ErrorType.Technical) {
                if (!this.technicalErrorDialogIsOpen) {
                  this.technicalErrorDialogIsOpen &#x3D; true;
                  let dialog &#x3D; this.dialog.open(TechnicalErrorDialogComponent, {data: error});
                  dialog.afterClosed().subscribe(() &#x3D;&gt; {
                    this.technicalErrorDialogIsOpen &#x3D; false
                  })
                }

              } else {
                this.dialog.open(BusinessErrorDialogComponent, {data: error});
              }
            }
          }
        }
      )
    });
  };
}


enum ErrorType {
  Technical, Validation
}

export class HttpRequestErrorProvider {
  _handled &#x3D; false;

  constructor(public _type: ErrorType, private error: TechnicalErrorModel | ValidationErrorModel) {

  }

  onTechnicalError(errorKey: string, handler: (error: TechnicalErrorModel) &#x3D;&gt; void) {
    if (this._type &#x3D;&#x3D; ErrorType.Technical &amp;&amp; (&lt;TechnicalErrorModel&gt;this.error).message &#x3D;&#x3D;&#x3D; errorKey) {
      handler(&lt;TechnicalErrorModel&gt;this.error);
      this._handled &#x3D; true;
    }
    return this;
  }

  onValidationError(exceptionClassName: string, handler: (error: ValidationErrorModel) &#x3D;&gt; void) {
    if (this._type &#x3D;&#x3D; ErrorType.Validation &amp;&amp;
        (&lt;ValidationErrorModel&gt;this.error).exceptionClassName &#x3D;&#x3D;&#x3D; exceptionClassName) {
      handler(&lt;ValidationErrorModel&gt;this.error);
      this._handled &#x3D; true;
    }
    return this;
  }

}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'HttpRequestErrorProvider.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
